Commit:    be7b0bc3ec02e4f223920ee6397f9c4993eb7df5
Author:    Nikita Popov <ni...@php.net>         Mon, 17 Dec 2012 22:02:32 +0100
Parents:   24f1ef1b0254d4b8341aa9d74ca450e89c2a8683
Branches:  PHP-5.5 master

Link:       
http://git.php.net/?p=php-src.git;a=commitdiff;h=be7b0bc3ec02e4f223920ee6397f9c4993eb7df5

Log:
Implement Generator::throw() method

Generator::throw($exception) throws an exception into the generator. The
exception is thrown at the current point of suspension within the generator.
It basically behaves as if the current yield statement were replaced with
a throw statement and the generator subsequently resumed.

Changed paths:
  M  NEWS
  A  Zend/tests/generators/throw_already_closed.phpt
  A  Zend/tests/generators/throw_caught.phpt
  A  Zend/tests/generators/throw_not_an_exception.phpt
  A  Zend/tests/generators/throw_rethrow.phpt
  A  Zend/tests/generators/throw_uncaught.phpt
  M  Zend/zend_generators.c


Diff:
diff --git a/NEWS b/NEWS
index 54b4455..b8fb42b 100644
--- a/NEWS
+++ b/NEWS
@@ -5,6 +5,7 @@ PHP                                                             
           NEWS
 - General improvements:
   . Fixed bug #63822 (Crash when using closures with ArrayAccess).
     (Nikita Popov)
+  . Add Generator::throw() method. (Nikita Popov)
 
 - cURL:
   . Added new functions curl_escape, curl_multi_setopt, curl_multi_strerror
diff --git a/Zend/tests/generators/throw_already_closed.phpt 
b/Zend/tests/generators/throw_already_closed.phpt
new file mode 100644
index 0000000..e918e54
--- /dev/null
+++ b/Zend/tests/generators/throw_already_closed.phpt
@@ -0,0 +1,23 @@
+--TEST--
+Generator::throw() on an already closed generator
+--FILE--
+<?php
+
+function gen() {
+    yield;
+}
+
+$gen = gen();
+$gen->next();
+$gen->next();
+var_dump($gen->valid());
+$gen->throw(new Exception('test'));
+
+?>
+--EXPECTF--
+bool(false)
+
+Fatal error: Uncaught exception 'Exception' with message 'test' in %s:%d
+Stack trace:
+#0 {main}
+  thrown in %s on line %d
diff --git a/Zend/tests/generators/throw_caught.phpt 
b/Zend/tests/generators/throw_caught.phpt
new file mode 100644
index 0000000..0c3f8e9
--- /dev/null
+++ b/Zend/tests/generators/throw_caught.phpt
@@ -0,0 +1,25 @@
+--TEST--
+Generator::throw() where the exception is caught in the generator
+--FILE--
+<?php
+
+function gen() {
+    try {
+        yield;
+    } catch (RuntimeException $e) {
+        echo $e, "\n\n";
+    }
+
+    yield 'result';
+}
+
+$gen = gen();
+var_dump($gen->throw(new RuntimeException('Test')));
+
+?>
+--EXPECTF--
+exception 'RuntimeException' with message 'Test' in %s:%d
+Stack trace:
+#0 {main}
+
+string(6) "result"
diff --git a/Zend/tests/generators/throw_not_an_exception.phpt 
b/Zend/tests/generators/throw_not_an_exception.phpt
new file mode 100644
index 0000000..d93903e
--- /dev/null
+++ b/Zend/tests/generators/throw_not_an_exception.phpt
@@ -0,0 +1,15 @@
+--TEST--
+Generator::throw() with something that's not an exception
+--FILE--
+<?php
+
+function gen() {
+    yield;
+}
+
+$gen = gen();
+$gen->throw(new stdClass);
+
+?>
+--EXPECTF--
+Fatal error: Exceptions must be valid objects derived from the Exception base 
class in %s on line %d
diff --git a/Zend/tests/generators/throw_rethrow.phpt 
b/Zend/tests/generators/throw_rethrow.phpt
new file mode 100644
index 0000000..267f5f0
--- /dev/null
+++ b/Zend/tests/generators/throw_rethrow.phpt
@@ -0,0 +1,32 @@
+--TEST--
+Generator::throw() where the generator throws a different exception
+--FILE--
+<?php
+
+function gen() {
+    try {
+        yield;
+    } catch (RuntimeException $e) {
+        echo 'Caught: ', $e, "\n\n";
+
+        throw new LogicException('new throw');
+    }
+}
+
+$gen = gen();
+var_dump($gen->throw(new RuntimeException('throw')));
+
+?>
+--EXPECTF--
+Caught: exception 'RuntimeException' with message 'throw' in %s:%d
+Stack trace:
+#0 {main}
+
+
+Fatal error: Uncaught exception 'LogicException' with message 'new throw' in 
%s:%d
+Stack trace:
+#0 [internal function]: gen()
+#1 %s(%d): Generator->throw(Object(RuntimeException))
+#2 {main}
+  thrown in %s on line %d
+
diff --git a/Zend/tests/generators/throw_uncaught.phpt 
b/Zend/tests/generators/throw_uncaught.phpt
new file mode 100644
index 0000000..f06cff1
--- /dev/null
+++ b/Zend/tests/generators/throw_uncaught.phpt
@@ -0,0 +1,19 @@
+--TEST--
+Generator::throw() where the exception is not caught in the generator
+--FILE--
+<?php
+
+function gen() {
+    yield 'thisThrows';
+    yield 'notReached';
+}
+
+$gen = gen();
+var_dump($gen->throw(new RuntimeException('test')));
+
+?>
+--EXPECTF--
+Fatal error: Uncaught exception 'RuntimeException' with message 'test' in %s:%d
+Stack trace:
+#0 {main}
+  thrown in %s on line %d
diff --git a/Zend/zend_generators.c b/Zend/zend_generators.c
index b16687c..9c65c53 100644
--- a/Zend/zend_generators.c
+++ b/Zend/zend_generators.c
@@ -431,10 +431,6 @@ static zend_function *zend_generator_get_constructor(zval 
*object TSRMLS_DC) /*
 
 ZEND_API void zend_generator_resume(zend_generator *generator TSRMLS_DC) /* 
{{{ */
 {
-       if (EG(exception)) {
-               return;
-       }
-
        /* The generator is already closed, thus can't resume */
        if (!generator->execute_data) {
                return;
@@ -617,7 +613,7 @@ ZEND_METHOD(Generator, next)
 }
 /* }}} */
 
-/* {{{ proto mixed Generator::send()
+/* {{{ proto mixed Generator::send(mixed $value)
  * Sends a value to the generator */
 ZEND_METHOD(Generator, send)
 {
@@ -648,6 +644,44 @@ ZEND_METHOD(Generator, send)
 }
 /* }}} */
 
+/* {{{ proto mixed Generator::throw(Exception $exception)
+ * Throws an exception into the generator */
+ZEND_METHOD(Generator, throw)
+{
+       zval *exception, *exception_copy;
+       zend_generator *generator;
+
+       if (zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC, "z", &exception) 
== FAILURE) {
+               return;
+       }
+
+       ALLOC_ZVAL(exception_copy);
+       MAKE_COPY_ZVAL(&exception, exception_copy);
+
+       generator = (zend_generator *) zend_object_store_get_object(getThis() 
TSRMLS_CC);
+
+       if (generator->execute_data) {
+               /* Throw the exception in the context of the generator */
+               zend_execute_data *current_execute_data = 
EG(current_execute_data);
+               EG(current_execute_data) = generator->execute_data;
+
+               zend_throw_exception_object(exception_copy TSRMLS_CC);
+
+               EG(current_execute_data) = current_execute_data;
+
+               zend_generator_resume(generator TSRMLS_CC);
+
+               if (generator->value) {
+                       RETURN_ZVAL(generator->value, 1, 0);
+               }
+       } else {
+               /* If the generator is already closed throw the exception in the
+                * current context */
+               zend_throw_exception_object(exception_copy TSRMLS_CC);
+       }
+}
+/* }}} */
+
 /* {{{ proto void Generator::__wakeup()
  * Throws an Exception as generators can't be serialized */
 ZEND_METHOD(Generator, __wakeup)
@@ -790,6 +824,10 @@ ZEND_BEGIN_ARG_INFO_EX(arginfo_generator_send, 0, 0, 1)
        ZEND_ARG_INFO(0, value)
 ZEND_END_ARG_INFO()
 
+ZEND_BEGIN_ARG_INFO_EX(arginfo_generator_throw, 0, 0, 1)
+       ZEND_ARG_INFO(0, exception)
+ZEND_END_ARG_INFO()
+
 static const zend_function_entry generator_functions[] = {
        ZEND_ME(Generator, rewind,   arginfo_generator_void, ZEND_ACC_PUBLIC)
        ZEND_ME(Generator, valid,    arginfo_generator_void, ZEND_ACC_PUBLIC)
@@ -797,6 +835,7 @@ static const zend_function_entry generator_functions[] = {
        ZEND_ME(Generator, key,      arginfo_generator_void, ZEND_ACC_PUBLIC)
        ZEND_ME(Generator, next,     arginfo_generator_void, ZEND_ACC_PUBLIC)
        ZEND_ME(Generator, send,     arginfo_generator_send, ZEND_ACC_PUBLIC)
+       ZEND_ME(Generator, throw,    arginfo_generator_throw, ZEND_ACC_PUBLIC)
        ZEND_ME(Generator, __wakeup, arginfo_generator_void, ZEND_ACC_PUBLIC)
        ZEND_FE_END
 };


--
PHP CVS Mailing List (http://www.php.net/)
To unsubscribe, visit: http://www.php.net/unsub.php

Reply via email to